﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Imaging;
using System.Runtime.InteropServices;

using Microsoft.Kinect;

namespace depthID
{
    public partial class Form1 : Form
    {
        KinectSensor sensor;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            sensor = KinectSensor.KinectSensors[0];
            sensor.DepthStream.Enable(DepthImageFormat.Resolution320x240Fps30);
            sensor.SkeletonStream.Enable();
            sensor.DepthFrameReady += DepthFrameReady;
            sensor.Start();
        }

        void DepthFrameReady(object sender, DepthImageFrameReadyEventArgs e)
        {
            DepthImageFrame imageFrame = e.OpenDepthImageFrame();
            if (imageFrame != null)
            {
                short[] pixelData = new short[imageFrame.PixelDataLength];
                imageFrame.CopyPixelDataTo(pixelData);
                int[] depth = new int[imageFrame.PixelDataLength];
                int[] player = new int[imageFrame.PixelDataLength];
                int[] playercoded = new int[imageFrame.PixelDataLength];

                for (int i = 0; i < depth.Length; i++)
                {

                    player[i] = pixelData[i] & DepthImageFrame.PlayerIndexBitmask;
                    depth[i] = ((ushort)pixelData[i]) >> DepthImageFrame.PlayerIndexBitmaskWidth;


                    playercoded[i] = 0;
                    if ((player[i] & 0x01) == 0x01)
                        playercoded[i] |= 0xFF0000;
                    if ((player[i] & 0x02) == 0x02)
                        playercoded[i] |= 0x00FF00;
                    if ((player[i] & 0x04) == 0x04)
                        playercoded[i] |= 0x0000FF;
                }
                pictureBox1.Image = IntToBitmap(depth, imageFrame.Width, imageFrame.Height);
                pictureBox2.Image = IntToBitmap(playercoded, imageFrame.Width, imageFrame.Height);
            }
        }







        Bitmap IntToBitmap(int[] array, int w, int h)
        {
            Bitmap bmap = new Bitmap(
              w,
              h,
              PixelFormat.Format32bppRgb
              );
            BitmapData bmapdata = bmap.LockBits(
              new Rectangle(0, 0, w, h),
              ImageLockMode.WriteOnly,
              bmap.PixelFormat);
            IntPtr ptr = bmapdata.Scan0;
            Marshal.Copy(array,
            0,
            ptr,
            array.Length);
            bmap.UnlockBits(bmapdata);
            return bmap;
        }
          
  
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            sensor.Stop();
            Environment.Exit(0);
        }
    }
}
